/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of managesieve.xs. Do not edit this file, edit managesieve.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "managesieve.xs"
/*
 * Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The name "Carnegie Mellon University" must not be used to
 *    endorse or promote products derived from this software without
 *    prior written permission. For permission or any legal
 *    details, please contact
 *      Carnegie Mellon University
 *      Center for Technology Transfer and Enterprise Creation
 *      4615 Forbes Avenue
 *      Suite 302
 *      Pittsburgh, PA  15213
 *      (412) 268-7393, fax: (412) 268-7395
 *      innovation@andrew.cmu.edu
 *
 * 4. Redistributions of any form whatsoever must retain the following
 *    acknowledgment:
 *    "This product includes software developed by Computing Services
 *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
 *
 * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
 * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
 * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
 * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
 * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#ifdef __cplusplus
}
#endif

#include <netdb.h>
#include <netinet/in.h>
#include <sys/file.h>
#include <sys/socket.h>

#include "managesieve/managesieve.h"

typedef struct xscyrus *Sieveobj;
static char *globalerr = NULL;

#include "isieve.h"
#include "util.h"
#include "xmalloc.h"

void fatal(const char *s, int t)
{
    croak("failure: %s", s);
    exit(-1);
}

static int perlsieve_getpass(sasl_conn_t *conn, void *context,
                             int id, sasl_secret_t **psecret)
{
    int count;
    dSP ;
    char *tmp;
    SV * func = (SV *) context;

    ENTER ;
    SAVETMPS;
    PUSHMARK(sp) ;

    XPUSHs(sv_2mortal(newSVpv("password", 0)));
    XPUSHs(sv_2mortal(newSVpv("Please enter your password", 0)));

    PUTBACK ;
    count = perl_call_sv(func, G_SCALAR);
    SPAGAIN ;
    if (count != 1)
        croak("Big trouble\n") ;
    tmp = POPp;

    /* copy result */
    *psecret = xmalloc(sizeof(sasl_secret_t) + strlen(tmp) + 2);
    strcpy((char *) (*psecret)->data ,tmp);
    (*psecret)->len = strlen(tmp);

    PUTBACK ;
    FREETMPS ;
    LEAVE ;

    PUTBACK ;

    return SASL_OK;
}

static int perlsieve_simple(void *context, int id,
                            unsigned char **result, unsigned *len)
{
    int count;
    dSP ;
    char *tmp;
    SV * func = (SV *) context;

    ENTER ;
    SAVETMPS;
    PUSHMARK(sp) ;
    if (id == SASL_CB_USER) {
            XPUSHs(sv_2mortal(newSVpv("username", 0)));
            XPUSHs(sv_2mortal(newSVpv("Please enter your username", 0)));
    } else if (id == SASL_CB_AUTHNAME) {
            XPUSHs(sv_2mortal(newSVpv("authname", 0)));
            XPUSHs(sv_2mortal(newSVpv("Please enter your authentication name", 0)));
    } else if (id == SASL_CB_GETREALM) {
            XPUSHs(sv_2mortal(newSVpv("realm", 0)));
            XPUSHs(sv_2mortal(newSVpv("Please enter your realm", 0)));
    } else {
            croak("Bad callback\n");
            return SASL_FAIL;
    }

    PUTBACK ;
    count = perl_call_sv(func, G_SCALAR);
    SPAGAIN ;
    if (count != 1)
        croak("Big trouble\n") ;
    tmp = POPp;

    /* copy result */
    *result = xmalloc(strlen(tmp) + 2);
    strcpy((char *) *result, tmp);
    if (len) *len = strlen((char *) *result);

    PUTBACK ;
    FREETMPS ;
    LEAVE ;

    PUTBACK ;

    return SASL_OK;
}


static void *
call_listcb(unsigned char *name, int isactive, void *rock)
{
    dSP ;
    PUSHMARK(sp) ;
    XPUSHs(sv_2mortal(newSVpv((const char *) name, 0)));
    XPUSHs(sv_2mortal(newSViv(isactive)));
    PUTBACK ;

    /* call perl func */
    perl_call_sv((SV *)rock, G_DISCARD) ;
    return NULL;
}


#line 180 "managesieve.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 324 "managesieve.c"

XS_EUPXS(XS_Cyrus__SIEVE__managesieve_sieve_get_handle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cyrus__SIEVE__managesieve_sieve_get_handle)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "servername, username_cb, authname_cb, password_cb, realm_cb");
    {
#line 179 "managesieve.xs"
    Sieveobj ret = NULL;
    sasl_callback_t *callbacks;
    int port;
    int r;
    struct servent *serv;
    char *mechlist=NULL,*mlist=NULL;
    const char *mtried;
    isieve_t *obj;
    char *p;
    sasl_ssf_t ssf;

#line 345 "managesieve.c"
	Sieveobj	RETVAL;
	char *	servername = (char *)SvPV_nolen(ST(0))
;
	SV *	username_cb = ST(1)
;
	SV *	authname_cb = ST(2)
;
	SV *	password_cb = ST(3)
;
	SV *	realm_cb = ST(4)
;
#line 192 "managesieve.xs"
    /* xxx this gets leaked! */
    callbacks = safemalloc(5 * sizeof(sasl_callback_t));

    callbacks[0].id = SASL_CB_USER;
    callbacks[0].proc = (int (*)(void))&perlsieve_simple;
    callbacks[0].context = username_cb;
    callbacks[1].id = SASL_CB_AUTHNAME;
    callbacks[1].proc = (int (*)(void))&perlsieve_simple;
    callbacks[1].context = authname_cb;
    callbacks[2].id = SASL_CB_GETREALM;
    callbacks[2].proc = (int (*)(void))&perlsieve_simple;
    callbacks[2].context = realm_cb;
    callbacks[3].id = SASL_CB_PASS;
    callbacks[3].proc = (int (*)(void))&perlsieve_getpass;
    callbacks[3].context = password_cb;
    callbacks[4].id = SASL_CB_LIST_END;

    /* see if we have server:port (or IPv6, etc)*/
    p = servername;
    if (*servername == '[') {
        if ((p = strrchr(servername + 1, ']')) != NULL) {
            *p++ = '\0';
            servername++;                       /* skip first bracket */
        } else
            p = servername;
    }
    if ((p = strchr(p, ':'))) {
        *p++ = '\0';
        port = atoi(p);
    } else {
        /* map port -> num */
        serv = getservbyname("sieve", "tcp");
        if (serv == NULL) {
            port = 4190;
        } else {
            port = ntohs(serv->s_port);
        }
    }

    if (init_net(servername, port, &obj)) {
        globalerr = "network initialization failed";
        XSRETURN_UNDEF;
    }

    if (init_sasl(obj, 128, callbacks)) {
        globalerr = "sasl initialization failed";
        sieve_free_net(obj);
        XSRETURN_UNDEF;
    }

    ret = xmalloc(sizeof(struct xscyrus));
    ret->class = safemalloc(20);
    strcpy(ret->class,"managesieve");
    ret->isieve = obj;
    ret->errstr = NULL;

    mechlist=read_capability(obj);
    if (!mechlist) {
        globalerr = "sasl mech list empty";
        free(ret);
        XSRETURN_UNDEF;
    }

    mlist = (char*) xstrdup(mechlist);

    /* loop through all the mechanisms */
    do {
        mtried = NULL;
        r = auth_sasl(mlist, obj, &mtried, &ssf, &globalerr);

        if (r) init_sasl(obj, 128, callbacks);

        if (mtried) {
            char *newlist = (char*) xmalloc(strlen(mlist)+1);
            char *mtr = (char*) xstrdup(mtried);
            char *tmp;

            ucase(mtr);
            tmp = strstr(mlist,mtr);
            *tmp ='\0';
            strcpy(newlist, mlist);
            tmp++;

            tmp = strchr(tmp,' ');
            if (tmp) {
                strcat(newlist,tmp);
            }

            free(mtr);
            free(mlist);
            mlist = newlist;
        }
    } while (r && mtried);

    if (r) {
        /* we failed */
        safefree(ret->class);
        free(ret);
        free(mechlist);
        XSRETURN_UNDEF;
    }

    if (ssf) {
        /* SASL security layer negotiated --
           check if SASL mech list changed */
        if (detect_mitm(obj, mechlist)) {
            globalerr = "possible MITM attack: "
                "list of available SASL mechamisms changed";
            free(ret);
            free(mechlist);
            XSRETURN_UNDEF;
        }
    }
    free(mechlist);

    ST(0) = sv_newmortal();
    sv_setref_pv(ST(0), ret->class, (void *) ret);
#line 475 "managesieve.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Cyrus__SIEVE__managesieve_sieve_get_error); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cyrus__SIEVE__managesieve_sieve_get_error)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	char *	RETVAL;
	dXSTARG;
	Sieveobj	obj;

                IV tmp = SvIV((SV*)SvRV(ST(0)));
                obj = (Sieveobj) tmp
;
#line 313 "managesieve.xs"
    RETVAL = obj->errstr;
#line 497 "managesieve.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Cyrus__SIEVE__managesieve_sieve_get_global_error); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cyrus__SIEVE__managesieve_sieve_get_global_error)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	char *	RETVAL;
	dXSTARG;
#line 320 "managesieve.xs"
    RETVAL = globalerr;
#line 515 "managesieve.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Cyrus__SIEVE__managesieve_sieve_logout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cyrus__SIEVE__managesieve_sieve_logout)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	int	RETVAL;
	dXSTARG;
	Sieveobj	obj;

                IV tmp = SvIV((SV*)SvRV(ST(0)));
                obj = (Sieveobj) tmp
;
#line 327 "managesieve.xs"
    /* xxx this leaves the object unusable */
    isieve_logout(&(obj->isieve));
    XSRETURN_UNDEF;
#line 540 "managesieve.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Cyrus__SIEVE__managesieve_sieve_put_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cyrus__SIEVE__managesieve_sieve_put_file)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "obj, filename");
    {
	int	RETVAL;
	dXSTARG;
	Sieveobj	obj;
	char *	filename = (char *)SvPV_nolen(ST(1))
;

                IV tmp = SvIV((SV*)SvRV(ST(0)));
                obj = (Sieveobj) tmp
;
#line 334 "managesieve.xs"
    RETVAL = isieve_put_file(obj->isieve, filename, NULL, &obj->errstr);
#line 564 "managesieve.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Cyrus__SIEVE__managesieve_sieve_put_file_withdest); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cyrus__SIEVE__managesieve_sieve_put_file_withdest)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "obj, filename, destname");
    {
	int	RETVAL;
	dXSTARG;
	Sieveobj	obj;
	char *	filename = (char *)SvPV_nolen(ST(1))
;
	char *	destname = (char *)SvPV_nolen(ST(2))
;

                IV tmp = SvIV((SV*)SvRV(ST(0)));
                obj = (Sieveobj) tmp
;
#line 341 "managesieve.xs"
    RETVAL = isieve_put_file(obj->isieve, filename, destname, &obj->errstr);
#line 591 "managesieve.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Cyrus__SIEVE__managesieve_sieve_put); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cyrus__SIEVE__managesieve_sieve_put)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "obj, name, data");
    {
	int	RETVAL;
	dXSTARG;
	Sieveobj	obj;
	char *	name = (char *)SvPV_nolen(ST(1))
;
	char *	data = (char *)SvPV_nolen(ST(2))
;

                IV tmp = SvIV((SV*)SvRV(ST(0)));
                obj = (Sieveobj) tmp
;
#line 348 "managesieve.xs"
    RETVAL = isieve_put(obj->isieve, name, data, strlen(data), &obj->errstr);
#line 618 "managesieve.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Cyrus__SIEVE__managesieve_sieve_delete); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cyrus__SIEVE__managesieve_sieve_delete)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "obj, name");
    {
	int	RETVAL;
	dXSTARG;
	Sieveobj	obj;
	char *	name = (char *)SvPV_nolen(ST(1))
;

                IV tmp = SvIV((SV*)SvRV(ST(0)));
                obj = (Sieveobj) tmp
;
#line 355 "managesieve.xs"
    RETVAL = isieve_delete(obj->isieve, name, &obj->errstr);
#line 643 "managesieve.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Cyrus__SIEVE__managesieve_sieve_list); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cyrus__SIEVE__managesieve_sieve_list)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "obj, cb");
    {
	int	RETVAL;
	dXSTARG;
	Sieveobj	obj;
	SV *	cb = ST(1)
;

                IV tmp = SvIV((SV*)SvRV(ST(0)));
                obj = (Sieveobj) tmp
;
#line 362 "managesieve.xs"
    RETVAL = isieve_list(obj->isieve, (isieve_listcb_t *) &call_listcb,
                         cb, &obj->errstr);
#line 669 "managesieve.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Cyrus__SIEVE__managesieve_sieve_activate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cyrus__SIEVE__managesieve_sieve_activate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "obj, name");
    {
	int	RETVAL;
	dXSTARG;
	Sieveobj	obj;
	char *	name = (char *)SvPV_nolen(ST(1))
;

                IV tmp = SvIV((SV*)SvRV(ST(0)));
                obj = (Sieveobj) tmp
;
#line 370 "managesieve.xs"
    RETVAL = isieve_activate(obj->isieve, name, &obj->errstr);
#line 694 "managesieve.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Cyrus__SIEVE__managesieve_sieve_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cyrus__SIEVE__managesieve_sieve_get)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "obj, name, output");
    {
	int	RETVAL;
	dXSTARG;
	Sieveobj	obj;
	char *	name = (char *)SvPV_nolen(ST(1))
;
	char *	output = (char *)SvPV_nolen(ST(2))
;

                IV tmp = SvIV((SV*)SvRV(ST(0)));
                obj = (Sieveobj) tmp
;
#line 377 "managesieve.xs"
    RETVAL = isieve_get(obj->isieve, name, &output, &obj->errstr);

#line 722 "managesieve.c"
	sv_setpv((SV*)ST(2), output);
	SvSETMAGIC(ST(2));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Cyrus__SIEVE__managesieve); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Cyrus__SIEVE__managesieve)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Cyrus::SIEVE::managesieve::sieve_get_handle", XS_Cyrus__SIEVE__managesieve_sieve_get_handle, file, "$$$$$");
        (void)newXSproto_portable("Cyrus::SIEVE::managesieve::sieve_get_error", XS_Cyrus__SIEVE__managesieve_sieve_get_error, file, "$");
        (void)newXSproto_portable("Cyrus::SIEVE::managesieve::sieve_get_global_error", XS_Cyrus__SIEVE__managesieve_sieve_get_global_error, file, "");
        (void)newXSproto_portable("Cyrus::SIEVE::managesieve::sieve_logout", XS_Cyrus__SIEVE__managesieve_sieve_logout, file, "$");
        (void)newXSproto_portable("Cyrus::SIEVE::managesieve::sieve_put_file", XS_Cyrus__SIEVE__managesieve_sieve_put_file, file, "$$");
        (void)newXSproto_portable("Cyrus::SIEVE::managesieve::sieve_put_file_withdest", XS_Cyrus__SIEVE__managesieve_sieve_put_file_withdest, file, "$$$");
        (void)newXSproto_portable("Cyrus::SIEVE::managesieve::sieve_put", XS_Cyrus__SIEVE__managesieve_sieve_put, file, "$$$");
        (void)newXSproto_portable("Cyrus::SIEVE::managesieve::sieve_delete", XS_Cyrus__SIEVE__managesieve_sieve_delete, file, "$$");
        (void)newXSproto_portable("Cyrus::SIEVE::managesieve::sieve_list", XS_Cyrus__SIEVE__managesieve_sieve_list, file, "$$");
        (void)newXSproto_portable("Cyrus::SIEVE::managesieve::sieve_activate", XS_Cyrus__SIEVE__managesieve_sieve_activate, file, "$$");
        (void)newXSproto_portable("Cyrus::SIEVE::managesieve::sieve_get", XS_Cyrus__SIEVE__managesieve_sieve_get, file, "$$$");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

